var workRec = {};
const BuildToolbar = function(loc, type, comment) {
    var lstBTN = `${type}LastBtn`;
    var nwBTN = `${type}NewBtn`;
    var mID = 0;
    var disabled = "";

    function main(){
      $(document).ready(() => {
        ORACLE_SERVICE_CLOUD.extension_loader.load("wjpcustToolbar", "1").then((extensionProvider) => {
          extensionProvider.getGlobalContext().then((globalContext)  => {
            globalContext.registerAction("set"+type, (param)  =>
            {
              mID = param;
              console.log("Printing the param that needs to set globalcontext");
              console.log(param);
              switch (mID) {
                case 0:
                  document.getElementById(`${lstBTN}`).disabled = true;
                  break;
                default:
                  document.getElementById(`${lstBTN}`).disabled = false;
              }
              attach(mID);
              });
            });
          }).then(() => {
            $(`#${loc} tbody`).after(
            `<tr>
              <td><b>${comment}</b>
              <td><button id="${lstBTN}" disabled>Last ${type}</button></td>
              <td><button id="${nwBTN}">New ${type}</button></td>
            </tr>`);
            attach(mID);
          });
        });
    }
    function attach(m){
      $(`#${lstBTN}`).unbind( "click" );
      $(`#${lstBTN}`).click(() => {
        open(m);
      });

      $(`#${nwBTN}`).unbind( "click" );
      $($(`#${nwBTN}`)).click(() => {
        open(0);
      });
    }
    //open workspace record..
    function open(recordID){
      ORACLE_SERVICE_CLOUD.extension_loader.load("wjpcustToolbar" , "1")
      .then(function(extensionProvider)
      {
        extensionProvider.registerWorkspaceExtension((WorkspaceRecord) => {
          switch (recordID) {
            case 0:
              WorkspaceRecord.createWorkspaceRecord(type, (workspaceRecord) => {
                callback(workspaceRecord);
              });
              break;
            default:
              WorkspaceRecord.editWorkspaceRecord(type, recordID, (workspaceRecord) => {
                callback(workspaceRecord);
              });
          }
        });
      });
    }
    function callback(workspaceRecord, recordID){
      addWorkspaceButton(workspaceRecord,recordID);
      //do something with workspace record
    }
    function addWorkspaceButton(workspaceRecord,recordID){
      workRec[workspaceRecord.getContextId()] = workspaceRecord;
      workspaceRecord.addRecordClosingListener((workspaceRecordEventParam) => {
        $("#"+workspaceRecord.getContextId()).remove();
      });
      $("#calls").append("<li class='tab' id='"+workspaceRecord.getContextId()+"' onclick='findAndFocus(\""+workspaceRecord.getContextId()+"\")'><div class='focus'>"+recordID+"</div><sup><i class='fa fa-window-close' onclick='stopEvent();return closeCurrentWorkspace(\""+workspaceRecord.getContextId()+"\")'></i></sup></li>");
    }
    function closeCurrentWorkspace(contextId){
      workspaceRecordMap[contextId].closeEditor().then(() => {
        $("#"+contextId).remove();
        workspaceRecordMap[contextId] = null;
      });
      return false;
    }

    function findAndFocus(contextId){
      workspaceRecordMap[contextId].findAndFocus(
        workspaceRecordMap[contextId].getWorkspaceRecordType(),
        workspaceRecordMap[contextId].getWorkspaceRecordId());
    }

    function stopEvent(e){
        var evt = e ? e:window.event;
        if (evt.stopPropagation)    evt.stopPropagation();
        if (evt.cancelBubble!=null) evt.cancelBubble = true;
    }

    return main();
}

export default BuildToolbar;
